<?php

/**
 * Provide a public-facing view for the plugin
 *
 * This file is used to markup the public-facing aspects of the plugin.
 *
 * @link       https://www.biuro.lt
 * @since      1.0.0
 *
 * @package    Biuro_Contacts
 * @subpackage Biuro_Contacts/public/partials
 */

/**
 * @link https://codex.wordpress.org/Creating_Options_Pages
 * @link https://www.smashingmagazine.com/2016/04/three-approaches-to-adding-configurable-fields-to-your-plugin/
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) die;
?>

<?php
    $nameValue = $_SESSION['employees--name-value'];
    $nameStatus = $_SESSION['employees--name-status'];
    $nameMessage = $_SESSION['employees--name-message'];
?>
    <div class="c-form--row">
        <label class="c-form--label" for="form-name"><?php _e('Name, surname', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap <?php if ($nameStatus) { echo "c-form--input-wrap--$nameStatus"; } ?>">
            <input type="text" class="c-form--input" id="form-name" name="name" value="<?php echo $nameValue; ?>" <?php if ($nameStatus == 'error'): ?> autofocus="autofocus" <?php endif; ?>>
        </div>
        <?php if ($nameMessage): ?>
            <div class="c-form--validation c-form--validation-<?php echo $nameStatus; ?>">
                <?php echo $nameMessage; ?>
            </div>
        <?php endif; ?>
    </div><!-- .c-form--row -->

<?php
    $phoneValue = $_SESSION['employees--phone-value'];
    $phoneStatus = $_SESSION['employees--phone-status'];
    $phoneMessage = $_SESSION['employees--phone-message'];
?>
    <div class="c-form--row">
        <label class="c-form--label" for="form-phone"><?php _e('Phone no.', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap <?php if ($phoneStatus) { echo "c-form--input-wrap--$phoneStatus"; } ?>">
            <input type="tel" class="c-form--input" id="form-phone" name="phone" value="<?php echo $phoneValue; ?>" <?php if ($nameStatus != 'error' && $phoneStatus == 'error'): ?> autofocus="autofocus" <?php endif; ?>>
        </div>
        <?php if ($phoneMessage): ?>
            <div class="c-form--validation c-form--validation-<?php echo $phoneStatus; ?>">
                <?php echo $phoneMessage; ?>
            </div>
        <?php endif; ?>
    </div><!-- .c-form--row -->

<?php
    $emailValue = $_SESSION['employees--email-value'];
    $emailStatus = $_SESSION['employees--email-status'];
    $emailMessage = $_SESSION['employees--email-message'];
?>
    <div class="c-form--row">
        <label class="c-form--label" for="form-email"><?php _e('Email address', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap <?php if ($emailStatus) { echo "c-form--input-wrap--$emailStatus"; } ?>">
                <input type="email" class="c-form--input" id="form-email" name="email" value="<?php echo $emailValue; ?>">
        </div>
        <?php if ($emailMessage): ?>
            <div class="c-form--validation c-form--validation-<?php echo $emailStatus; ?>">
                <?php echo $emailMessage; ?>
            </div>
        <?php endif; ?>
    </div><!-- .c-form--row -->

    <div class="c-form--row">
        <div class="c-form--submit-wrap">
            <button type="submit" class="o-btn c-btn--main c-btn--fill" name="s" value="1"><?php _e('Submit', 'biuro-contacts'); ?></button>
        </div>
    </div><!-- .c-form--row -->

<?php
    $agreeValue = $_SESSION['employees--agree-value'];
    $agreeStatus = $_SESSION['employees--agree-status'];
    $agreeMessage = $_SESSION['employees--agree-message'];
?>
    <div class="c-form--row">
        <div class="c-form--checkbox-wrap">
            <input id="form-agree" type="checkbox" class="c-form--checkbox <?php if ($agreeStatus) { echo "c-form--checkbox--$agreeStatus"; } ?>" name="agree" value="1" <?php if ($agreeValue): ?> checked="checked"<?php endif; ?>>
            <label class="c-form--label-checkbox" for="form-agree"><?php _e('Rem possimus, delectus unde enim dolores doloribus, recusandae a veritatis ducimus repudiandae iste eos voluptatum architecto mollitia?', 'biuro-contacts'); ?></label>
        </div>
        <?php if ($agreeMessage): ?>
            <div class="c-form--validation c-form--validation-<?php echo $agreeStatus; ?>">
                <?php echo $agreeMessage; ?>
            </div>
        <?php endif; ?>
    </div><!-- .c-form--row -->
