<?php

/**
 * Provide a public-facing view for the plugin
 *
 * This file is used to markup the public-facing aspects of the plugin.
 *
 * @link       https://www.biuro.lt
 * @since      1.0.0
 *
 * @package    Biuro_Contacts
 * @subpackage Biuro_Contacts/public/partials
 */

/**
 * @link https://codex.wordpress.org/Creating_Options_Pages
 * @link https://www.smashingmagazine.com/2016/04/three-approaches-to-adding-configurable-fields-to-your-plugin/
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) die;
?>
    <div class="c-form--row">
        <label class="c-form--label" for="form-city"><?php _e('City', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap">
            <input type="text" class="c-form--input" id="form-city" name="city" value="" autofocus="autofocus">
        </div>
    </div><!-- .c-form--row -->

    <div class="c-form--row">
        <label class="c-form--label" for="form-message"><?php _e('Message', 'biuro-contacts'); ?></label>
        <div class="c-form--textarea-wrap">
            <textarea name="message" id="form-message" cols="30" rows="3" class="c-form--textarea"></textarea>
        </div>
    </div><!-- .c-form--row -->

    <div class="c-form--row">
        <label class="c-form--label" for="form-cv"><?php _e('CV', 'biuro-contacts'); ?></label>
        <div class="c-form--input-wrap">
            <input type="file" class="c-form--input" id="form-cv" name="cv" value="">
        </div>
    </div><!-- .c-form--row -->

    <div class="c-form--row">
        <div class="c-form--submit-wrap">
            <button type="submit" class="o-btn c-btn--main c-btn--fill" name="s" value="2"><?php _e('Submit', 'biuro-contacts'); ?></button>
        </div>
    </div><!-- .c-form--row -->

    <div class="c-form--row">
        <div class="c-form--checkbox-wrap">
            <input id="form-confirm" type="checkbox" class="c-form--checkbox" name="confirm" value="1">
            <label class="c-form--label-checkbox" for="form-confirm"><?php _e('Noster apster lorem ipsum dolor sit amet, consectetur adipisicing elit?', 'biuro-contacts'); ?></label>
        </div>
    </div><!-- .c-form--row -->
