<?php
/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

get_header(); ?>

    <div id="content" class="l-content--main">
        <main id="main" class="l-main">

            <div class="c-404">
                <p class="c-404--heading">404</p>
                <p class="c-404--message"><?php _e('Sorry, the page you are looking for does not exist!', 'biuro'); ?></p>
                <p>
                    <a href="<?php echo pll_home_url(); ?>" class="o-btn c-btn--main"><?php _e('Return to homepage', 'biuro'); ?></a>
                </p>
            </div>

<?php
/*
    <div class="c-404">
        <p class="c-404--heading">404</p>
        <p class="c-404--message">Atsiprašome, bet puslapis kurio jūs ieškote neegzistuoja!</p>
        <p>
            <a href="<?php echo pll_home_url(); ?>" class="o-btn c-btn--main">Grįžti į pagrindinį puslapį</a>
        </p>
    </div>
*/
 ?>

        </main><!-- .l-main -->
    </div><!-- #content -->

<?php get_footer();
