<?php
/**
 * Template Name: Divisions page
 *
 * This is the page for a divisions listing with google map
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

global $post;

$pageID = $post->ID;

get_header(); ?>

    <div class="l-map" id="js-map--divisions" data-lang="<?php echo pll_current_language(); ?>"></div>

    <div id="content" class="l-content--divisions">
        <main id="main" class="l-main l-main--divisions">

<?php
    while ( have_posts() ) :

        the_post();
        the_content();

    endwhile;

    $related = pods( 'division', $params )->find( array(
        'limit' => -1,
        'where'=>"page-id.ID = " . $pageID
    ) );

    $total = $related->total();


    $divisions = pods( 'division', array(
        'limit'   => -1
    ) );

    if ( 0 < $divisions->total() ):
        $cities = array();
?>
        <div class="c-divisions">
<?php
            if ( 1 < $divisions->total() ):

                $divisionsPage = new WP_Query( array(
                    'numberposts'   => 1,
                    'post_type'     => 'page',
                    'meta_key'      => 'divisions-page',
                    'meta_value'    => 'master'
                ) );

                if ( $divisionsPage->have_posts() ) :
                    while( $divisionsPage->have_posts() ) :
                        $divisionsPage->the_post();
?>
                        <a class="c-division <?php if ( $total == 0 ) { echo 'c-division--active'; } ?>" href="<?php the_permalink(); ?>"><?php _e('All', 'biuro'); ?></a>
<?php
                    endwhile;
                else:
?>
                    <span class="c-division"><?php _e('All', 'biuro'); ?></span>
<?php
                endif;
                wp_reset_query();

            endif;

            while ( $divisions->fetch() ) :
                $slug = $divisions->display( 'city.slug' );

                if ( !in_array($slug, $cities) && $divisions->display( 'name' ) ) :
                    $page = $divisions->field( 'page-id' );

                    if  ( !empty( $page ) ):
?>
                        <a class="js-division c-division <?php if ( $pageID == $page['ID'] ) { echo 'c-division--active'; } ?>" data-id="<?php echo $slug; ?>" href="<?php echo esc_url( get_permalink( $page['ID'] ) ); ?>"><?php echo $divisions->display( 'city' ); ?></a>
<?php
                    else:
?>
                        <span class="c-division"><?php echo $divisions->display( 'city' ); ?></span>
<?php
                    endif;

                    array_push($cities, $slug);
                endif;
            endwhile;
?>
            </div>
        </main><!-- .l-main -->
        <aside class="l-aside--divisions">
<?php
            echo do_shortcode('[biuro-contacts--employees lang="' . pll_current_language() . '"]');
?>
        </aside>
<?php
    endif;

?>

    </div><!-- #content -->

    <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBQjPQnLGLeICbpTTu8kLjVRrLUYYCTS2M" async defer></script>

<?php get_footer();
