<?php
/**
 * Template Name: Sales page
 *
 * The sales page template file
 * Learn more: https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

    get_header();
?>

    <div class="l-section l-section--sales-page">
        <div class="l-section--inner">
<?php
            while ( have_posts() ) :
?>
            <div class="c-heading c-heading--sales-page">
<?php
                the_post();
                the_content();
?>
            </div>
<?php
            endwhile;
?>
        </div>
    </div>

    <div id="content">
        <main id="main" class="l-main">

<?php
            if ( is_active_sidebar( 'sales_page_services' ) ) :
                dynamic_sidebar( 'sales_page_services' );
            endif;
 ?>

<?php
            if ( is_active_sidebar( 'sales_page_values' ) ) :
                dynamic_sidebar( 'sales_page_values' );
            endif;
 ?>

<?php
            if ( is_active_sidebar( 'sales_page_sections' ) ) :
                dynamic_sidebar( 'sales_page_sections' );
            endif;
 ?>

        <div class="c-trust">
            <div class="c-trust--inner">
                <h2 class="c-trust--heading"><?php _e('Trust in us', 'biuro'); ?></h2>
                <div class="c-trust--logos">
                    <img src="/wp-content/themes/biuro/i/trust/coca-cola.png" width="85" height="28" alt="">
                    <img src="/wp-content/themes/biuro/i/trust/maxima.png" width="96" height="22" alt="">
                    <img src="/wp-content/themes/biuro/i/trust/dpd.png" width="64" height="29" alt="">
                    <img src="/wp-content/themes/biuro/i/trust/avon.png" width="71" height="15" alt="">
                </div>
            </div>
        </div>

<?php
            if ( is_active_sidebar( 'sales_page_feedbacks' ) ) :
                dynamic_sidebar( 'sales_page_feedbacks' );
            endif;
 ?>
            <div class="c-contact">
                <div class="c-contact--inner">

                    <div class="c-contact--content">
                    <?php
                        if ( is_active_sidebar( 'sales_page_employers' ) ) :
                            dynamic_sidebar( 'sales_page_employers' );
                        endif;
                     ?>
                        <div class="c-contact--img">
                            <img src="/wp-content/themes/biuro/i/contact.png" alt="" width="328" height="95">
                        </div>
                    </div>

                    <div class="c-contact--form">
                        <?php
                            echo do_shortcode('[biuro-contacts--employers]');
                        ?>
                    </div>

                </div><!-- .c-contact--inner -->
            </div><!-- .c-contact -->

        </main><!-- .l-main -->
    </div><!-- #content -->

<?php get_footer();
