<?php
/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Biuro
 * @since 1.0
 * @version 1.0
 */

get_header();
?>
<div id="content" class="l-content--position">

    <div class="l-content--position-inner">

        <main id="main" class="l-main">

<?php
        while ( have_posts() ) :
?>
            <h1 class="c-job--title"><?php the_title(); ?></h1>

            <div class="c-job--content">
<?php
                the_post();
                the_content();
?>
            </div>
<?php
        endwhile;

        $pod = pods( 'job', get_the_id() );

        if (!is_array($pod->field( 'salary_from' )) && $pod->field( 'salary_from' ) > 0 || !is_array($pod->field( 'salary_to' )) && $pod->field( 'salary_to' ) > 0):
?>
            <p>
<?php
            if ($pod->field( 'salary_from' ) > 0):
?>
                <?php _e('Salary from', 'biuro'); ?>: <?php echo $pod->field( 'salary_from' ); ?>
                <br>
<?php
            endif;
            if ($pod->field( 'salary_to' ) > 0):
?>
                <?php _e('Salary to', 'biuro'); ?>: <?php echo $pod->field( 'salary_to' ); ?>
<?php
            endif;
?>

            </p>
<?php
        endif;

        $validPosition = date_i18n( 'Y-m-d', strtotime( $pod->field( 'valid' ) ) ) > date('Y-m-d') ? true : false;
?>
            <p>
                <?php _e('Published', 'biuro'); ?>: <?php echo date_i18n( get_option( 'date_format' ), strtotime( $pod->field( 'post_date' ) ) ); ?>
                <br>
                <?php _e('Valid till', 'biuro'); ?>: <?php echo date_i18n( get_option( 'date_format' ), strtotime( $pod->field( 'valid' ) ) ); ?>
            </p>

<?php
    if ($validPosition):
 ?>
            <div class="c-job--action">
                <button type="submit" class="js-inititate-position-form o-btn c-btn--main c-btn--fill" name="submit" value="1" data-id="action--form"><?php _e('Apply', 'biuro'); ?></button>
            </div>
<?php
    endif;
 ?>
        </main><!-- .l-main -->

        <aside class="l-aside--position">
<?php
        if ($validPosition):
            get_template_part( 'template-parts/layout/aside', 'job' );
        else:
            get_template_part( 'template-parts/layout/aside', 'job-inactive' );
        endif;
?>
        </aside><!-- .l-aside -->

    </div><!-- .l-content--position-inner -->

</div><!-- #content -->

<?php get_footer();
